﻿'All program codes are developed in the Biosimulation laboratory, Faculty of Life Sciences, Ritsumeikan University
'Reference; Publications
'A human ventricular myocyte model with refined representation of excitation-contraction coupling 
'Running title;                        'CICR in human ventricular cell model
'Authors;    'Y. Himeno†, K. Asakura†‡, C.Y. Cha†1, H. Memida†, T. Powell2, A. Amano†, and A. Noma†. 
'†Biosimulation Project, College of Life Sciences, Ritsumeikan University,
'Noji Higashi 1-1-1 Kusatsu-City, Shiga-prefecture, Japan
'‡Nippon Shinyaku, Co., Ltd., 14, Nishinosho-Monguchi-cho, Kisshoin, Minami-ku, Kyoto, Japan
'1Oxford Centre for Diabetes Endocrinology and Metabolism,
'University of Oxford, Churchill Hospital, Oxford, OX37 LJ, UK.
'2Department of Pharmacology, University of Oxford, Oxford OX1 3QT, UK

'Solution explorer lists all subclasses.
'Calculate.vb provides tools for Disk Write and Read
'Form.APClamp.vb ;   protocol of the Action potetial clamp experiment
'Form.General.vb;       protocol of the current clamp experiments
'Form.ICaLkinetics.vb ;   protocol to draw kinetics of LCC
'Form.RyRtransient.vb;  protocol of the state transition of the couplon model at the onset of action potential
'Form.scaleI1I2;  protocol for simulation of EAD  by varying the inactivation rate of INaL by using the scaling factor for kI1I2, and DAD by injecting 1~1.5 mM Ca into SRup compartment
'Form.VmClampIV.vb;  protocol of Vm clamp experiment
'Graph.vb; home-made tools for Graphics
'Graph2014.vb  home-made tools for Graphics in 2014
'Model.vb;    All equations of HuVEC model are described in this module class
'
'To select a 'Form' to run the protocol of interest, use 'My Project'  and select a Start up form (O) from the pull-down list in the solution explorer.


Public Class Form_ICaLkinetics

    Dim HV As New HuVECII

    '********** prepared pens **********
    Public BlackPen As Pen = New Pen(Color.Black, 1)
    Public BlackPen3 As Pen = New Pen(Color.Black, 3)
    Public BlackPen4 As Pen = New Pen(Color.Black, 4)
    Public BlackPen5 As Pen = New Pen(Color.Black, 5)
    Public BluePen As Pen = New Pen(Color.Blue, 1)
    Public BluePen3 As Pen = New Pen(Color.Blue, 3)
    Public BluePen4 As Pen = New Pen(Color.Blue, 4)
    Public BluePen5 As Pen = New Pen(Color.Blue, 5)
    Public RedPen As Pen = New Pen(Color.Red, 1)
    Public RedPen3 As Pen = New Pen(Color.Red, 3)
    Public RedPen4 As Pen = New Pen(Color.Red, 4)
    Public RedPen5 As Pen = New Pen(Color.Red, 5)
    Public ChocolatePen As Pen = New Pen(Color.Chocolate, 1)
    Public ChocolatePen3 As Pen = New Pen(Color.Chocolate, 3)
    Public ChocolatePen4 As Pen = New Pen(Color.Chocolate, 4)
    Public ChocolatePen5 As Pen = New Pen(Color.Chocolate, 5)
    Public GreenPen As Pen = New Pen(Color.Green, 1)
    Public GreenPen3 As Pen = New Pen(Color.Green, 3)
    Public OlivePen As Pen = New Pen(Color.Olive, 1)
    Public LimePen As Pen = New Pen(Color.Lime, 1)
    Public GreenYellowPen As Pen = New Pen(Color.GreenYellow, 1)
    Public LightCoralPen As Pen = New Pen(Color.LightCoral, 1)
    Public MagentaPen As Pen = New Pen(Color.Magenta, 1)
    Public VioletPen As Pen = New Pen(Color.Violet, 1)
    Public GrayPen As Pen = New Pen(Color.Gray, 1)
    Public GrayPen3 As Pen = New Pen(Color.Gray, 3)
    Public DarkCyanPen As Pen = New Pen(Color.DarkCyan, 1)
    Public DarkMagentaPen As Pen = New Pen(Color.DarkMagenta, 1)
    Public OrangePen As Pen = New Pen(Color.Orange, 1)
    Public cyanPen As Pen = New Pen(Color.Cyan, 1)
    Public yellowPen As Pen = New Pen(Color.Yellow, 1)

    '********** Graph option **********
    Dim graphCaRate1 As Graph2014
    Dim graphVmRate2 As Graph2014
    Dim graphCaKD3 As Graph2014
    Dim graphSS4 As Graph2014
    Dim graphTau As Graph2014
    Dim graphLCCCaRate6 As Graph2014
    ''******************************   Graph parameters **********************************
    Dim MinX1 As Double = -4                             'Ca concentration 0.1 uM
    Dim MaxX1 As Double = -1                             '10 uM
    Dim IntervalX1 As Double = 1

    Dim MinY1 As Double = -5                          'mV, ordinate, graph of membrane potential
    Dim MaxY1 As Double = 1
    Dim IntervalY1 As Double = 1

    Dim MinX2 As Double = -100                             'Vm
    Dim MaxX2 As Double = 50                             'mV
    Dim IntervalX2 As Double = 10

    Dim MinX3 As Double = -150                            'mV
    Dim MaxX3 As Double = 100                   'mV
    Dim IntervalX3 As Double = 20

    Dim minX4 As Double = -100
    Dim maxX4 As Double = 50
    Dim intervalX4 As Double = 10

    Dim minY4 As Double = 0
    Dim maxY4 As Double = 1
    Dim intervalY4 As Double = 0.1

    Dim minY5 As Double = 0
    Dim maxY5 As Double = 300
    Dim intervalY5 As Double = 20

    Dim pa As Double = 0.0625
    Dim pb As Double = 14

    Dim valueA As Double
    Dim valueB As Double
    Dim valueC As Double
    Dim valueD As Double

    Dim valueE As Double
    Dim valueF As Double
    Dim valueG As Double
    Dim valueH As Double

    Dim SFinact As Double

    Dim kVmp As Double
    Dim kVmn As Double
    Public VL As Double = -2                'mV a biasing voltage  Bolzmann-type relationship
    Public deltaVL As Double = 7         'mV slope of the voltage dependency  Bolzmann-type relationship
    Dim expF As Double
    Dim fVm As Double

    Dim mEtan1 As Double                                                                                  'modified Etan component 1
    Dim mEtan2 As Double                                                                                  'modified Etan component 2


    Dim firstRun As Boolean = True

    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click
        If firstRun = True Then
            DefineGraph()
            clear()                'Clear all graph
            firstRun = False
        End If

        DrawAxes()
        ReadForm()
        PlotData()              '***************  Experimental data of ICaL kinetics from 4 references ********************

        HV.Vm = MinX2         '*** Do Loop for Vm ****************
        Do
            '****************   LCC  Vm-dependent activation ******                                                                          ***** Panel A *******
            My.Application.DoEvents()
            'kVmp1 = 1.0 / (A * Math.Exp(-(Vm) / B) + C * Math.Exp(-(Vm) / D))         'activation rate  of LCC in the Kyoto model
            'graphVmRate2.PlotPoint(Vm, Math.Log10(kVmp1), RedPen)

            kVmp = 1.0 / (3.734 * Math.Exp(-HV.Vm / 8.5) + 0.35 * Math.Exp(-(HV.Vm) / 3500))    'alpha+, Vm-dependent acdtivation rate of LCC
            kVmn = 1.0 / (4.65 * Math.Exp(HV.Vm / 15) + 1.363 * Math.Exp(HV.Vm / 100))       'deactivation rateof LCC in the Kyoto model
            'kVmp = 1.0 / (4.2 * Math.Exp(-(HV.Vm + VshiftLCC) / 8.5) + 0.35 * Math.Exp(-(HV.Vm + VshiftLCC) / 3500))    'alpha+, Vm-dependent acdtivation rate of LCC
            'kVmn = 1.0 / (4.35 * Math.Exp((HV.Vm + VshiftLCC) / 15) + 1.35 * Math.Exp((HV.Vm + VshiftLCC) / 100))       'deactivation rateof LCC in the Kyoto model

            graphVmRate2.PlotPoint(HV.Vm, Math.Log10(kVmp), RedPen)
            graphVmRate2.PlotPoint(HV.Vm, Math.Log10(kVmn), BluePen)
            graphVmRate2.PlotPoint(HV.Vm, Math.Log10(kVmp + kVmn), GrayPen)
            graphSS4.PlotPoint(HV.Vm, kVmp / (kVmp + kVmn), ChocolatePen)

            HV.Vm = HV.Vm + 0.01
        Loop While HV.Vm < MaxX2

        '************* Adjustment ********************
        HV.KL = 4.4 / 1000
        Dim deno As Double = 3831 * 0.035
        HV.gD_nd = 0.065 * 1
        '**********************************  Adjustment
        HV.Cafree_jnc = 0.0001                   ' 1 uM
        HV.Cafree_SRrl = 0.7
        HV.Vm = MinX3
        Do                                                     '***********  LCC ******relative concentration of [Ca]nd  vs  Vm  ********panel B**********
            My.Application.DoEvents()
            expF = Math.Exp(-HV.Vm / HV.RTF2)
            HV.Ca_ndLR = (HV.Cafree_jnc + HV.Cafree_SRrl * HV.JRyR / HV.gD_nd + expF * HV.Cao * HV.JLCC / HV.gD_nd * (HV.Vm / HV.RTF2) / (1 - expF)) / (1 + HV.JRyR / HV.gD_nd + HV.JLCC / HV.gD_nd * HV.Vm / HV.RTF2 / (1 - expF))
            HV.Ca_ndL0 = (HV.Cafree_jnc + HV.JLCC / HV.gD_nd * HV.Cao * (HV.Vm / HV.RTF2 * expF) / (1 - expF)) / (1 + HV.JLCC / HV.gD_nd * HV.Vm / HV.RTF2 / (1 - expF))   'Ca conc. when LCC is open
            HV.Ca_nd0R = (HV.Cafree_jnc + HV.Cafree_SRrl * HV.JRyR / HV.gD_nd) / (1 + HV.JRyR / HV.gD_nd)

            graphCaKD3.PlotPoint(HV.Vm, Math.Log10(HV.Ca_ndL0), RedPen)       'plot of [Ca]nd against Vm
            graphCaKD3.PlotPoint(HV.Vm, Math.Log10(HV.Ca_ndLR), LimePen)       'plot of [Ca]nd against Vm
            graphCaKD3.PlotPoint(HV.Vm, Math.Log10(HV.Ca_nd0R), ChocolatePen)       'plot of [Ca]nd against Vm
            'graphCaKD3.PlotPoint(HV.Vm, Math.Log10(Cafree_jnc), VioletPen)       'plot of [Ca]nd against Vm

            graphCaKD3.PlotPoint(HV.Vm, Math.Log10(HV.KL), BluePen)                'Kd for the Ca mediated inactivation
            HV.Vm = HV.Vm + 0.01
        Loop While HV.Vm < MaxX3

        HV.Cafree_SRrl = 0.71
        Do
            HV.Vm = minX4
            Do                                                  '************* Ca-inactivation of LCC ****                                           ********** Panel D****
                My.Application.DoEvents()
                expF = Math.Exp(-HV.Vm / HV.RTF2)
                fVm = Math.Exp((HV.Vm - VL) / deltaVL)
                HV.Ca_ndL0 = (HV.Cafree_jnc + HV.JLCC / HV.gD_nd * HV.Cao * (HV.Vm / HV.RTF2 * expF) / (1 - expF)) / (1 + HV.JLCC / HV.gD_nd * HV.Vm / HV.RTF2 / (1 - expF))
                HV.Ca_ndLR = (HV.Cafree_jnc + HV.Cafree_SRrl * HV.JRyR / HV.gD_nd + expF * HV.Cao * HV.JLCC / HV.gD_nd * (HV.Vm / HV.RTF2) / (1 - expF)) / (1 + HV.JRyR / HV.gD_nd + HV.JLCC / HV.gD_nd * HV.Vm / HV.RTF2 / (1 - expF))

                kVmp = 1.0 / (3.734 * Math.Exp(-HV.Vm / 8.5) + 0.35 * Math.Exp(-HV.Vm / 3500))
                '************** replace kVmp for alfa+ ********************************
                'Dim mEtap As Double = Ca_ndLR / KL * kVmp / deno + Ca_ndLR * pa / (fVm + 1) / KL / deno      'modified Etap
                Dim mEtap As Double = HV.Ca_ndLR / HV.KL * kVmp / deno 'modified Etap
                'Dim mEtap As Double = Ca_ndL0 / KL * kVmp / deno 'modified Etap
                graphLCCCaRate6.PlotPoint(HV.Vm, Math.Log10(mEtap), RedPen)          'Log plot of Etap
                'Dim Etap As Double = Ca_ndL0 * (fVm + pa) / (fVm + 1) / tauLp / KL      'Vm-dependent term of the Eta+ in the original Hinch model

                '*******************  Fitting routine *************************
                'mEtan1 = 1.9 / SFinact / (valueA * Math.Exp(HV.Vm / valueB) + valueC * Math.Exp(Vm / valueD))
                'mEtan2 = 1 / SFinact / (valueE * Math.Exp(HV.Vm / valueF) + valueG * Math.Exp(Vm / valueH))
                'mEtan1 = 1.9 / (6400 * 2.4 * Math.Exp(HV.Vm / 10) + 51.2 * Math.Exp(Vm / 1000))
                mEtan1 = 1.9 / 1 / (15360 * Math.Exp(HV.Vm / 10) + 200 * Math.Exp(HV.Vm / 10000))
                mEtan2 = 1.9 / (256000 * Math.Exp(HV.Vm / -5) + 640 * Math.Exp(HV.Vm / -2000))
                graphLCCCaRate6.PlotPoint(HV.Vm, Math.Log10(mEtan1), BluePen)           'component 1
                graphLCCCaRate6.PlotPoint(HV.Vm, Math.Log10(mEtan2), GreenPen)           'component 2
                graphLCCCaRate6.PlotPoint(HV.Vm, Math.Log10(mEtan1 + mEtan2), ChocolatePen)    'sum of the two components
                graphSS4.PlotPoint(HV.Vm, (mEtan1 + mEtan2) / (mEtap + (mEtan1 + mEtan2)), RedPen)  'steady-state open probability of the Ca gate

                graphTau.PlotPoint(HV.Vm, 1 / (mEtap + mEtan1 + mEtan2), BlackPen)    'Tau of the Ca-mediated inactivation

                HV.Vm = HV.Vm + 0.01
            Loop While HV.Vm < maxX4
            HV.Cafree_SRrl = HV.Cafree_SRrl - 0.2
        Loop While HV.Cafree_SRrl >= 0.01



        HV.Cafree_SRrl = 0.71
        HV.Vm = minX4
        Do                                                  '************* Ca-inactivation of LCC ****                                           ********** Panel D****
            My.Application.DoEvents()
            expF = Math.Exp(-HV.Vm / HV.RTF2)
            fVm = Math.Exp((HV.Vm - VL) / deltaVL)
            HV.Ca_ndL0 = (HV.Cafree_jnc + HV.JLCC / HV.gD_nd * HV.Cao * (HV.Vm / HV.RTF2 * expF) / (1 - expF)) / (1 + HV.JLCC / HV.gD_nd * HV.Vm / HV.RTF2 / (1 - expF))
            HV.Ca_ndLR = (HV.Cafree_jnc + HV.Cafree_SRrl * HV.JRyR / HV.gD_nd + expF * HV.Cao * HV.JLCC / HV.gD_nd * (HV.Vm / HV.RTF2) / (1 - expF)) / (1 + HV.JRyR / HV.gD_nd + HV.JLCC / HV.gD_nd * HV.Vm / HV.RTF2 / (1 - expF))

            kVmp = 1.0 / (3.734 * Math.Exp(-HV.Vm / 8.5) + 0.35 * Math.Exp(-HV.Vm / 3500))
            '************** replace kVmp for alfa+ ********************************
            Dim mEtap As Double = HV.Ca_ndLR / HV.KL * kVmp / deno + HV.Ca_ndLR * pa / (fVm + 1) / HV.KL / deno      'modified Etap
            'Dim mEtap As Double = HV.Ca_ndLR / HV.KL * kVmp / deno 'modified Etap
            'Dim mEtap As Double = HV.Ca_ndL0 / HV.KL * kVmp / deno 'modified Etap
            'graphLCCCaRate6.PlotPoint(Vm, Math.Log10(mEtap), BluePen)          'Log plot of Etap
            'Dim Etap As Double = HV.Ca_ndL0 * (fVm + pa) / (fVm + 1) / HV.tauLp / HV.KL      'Vm-dependent term of the Eta+ in the original Hinch model

            '*******************  Fitting routine *************************
            'mEtan1 = 1.9 / SFinact / (valueA * Math.Exp(Vm / valueB) + valueC * Math.Exp(Vm / valueD))
            'mEtan2 = 1 / SFinact / (valueE * Math.Exp(Vm / valueF) + valueG * Math.Exp(Vm / valueH))
            'mEtan1 = 1.9 / (6400 * 2.4 * Math.Exp(Vm / 10) + 51.2 * Math.Exp(Vm / 1000))
            mEtan1 = 1.9 / 1 / (15360 * Math.Exp(HV.Vm / 10) + 200 * Math.Exp(HV.Vm / 10000))
            mEtan2 = 1.9 / (256000 * Math.Exp(HV.Vm / -5) + 640 * Math.Exp(HV.Vm / -2000))
            'graphLCCCaRate6.PlotPoint(Vm, Math.Log10(mEtan1), BluePen)           'component 1
            'graphLCCCaRate6.PlotPoint(Vm, Math.Log10(mEtan2), GreenPen)           'component 2
            'graphLCCCaRate6.PlotPoint(Vm, Math.Log10(mEtan1 + mEtan2), ChocolatePen)    'sum of the two components
            'graphSS4.PlotPoint(Vm, (mEtan1 + mEtan2) / (mEtap + (mEtan1 + mEtan2)), BluePen)  'steady-state open probability of the Ca gate

            'graphTau.PlotPoint(Vm, 1 / (mEtap + mEtan1 + mEtan2), BlackPen)    'Tau of the Ca-mediated inactivation

            HV.Vm = HV.Vm + 0.01
        Loop While HV.Vm < maxX4





    End Sub

    Private Sub ReadForm()
        SFinact = CDbl(txtSF.Text)

        valueA = CDbl(txtvalueA.Text)
        valueB = CDbl(txtvalueB.Text)
        valueC = CDbl(txtvalueC.Text)
        valueD = CDbl(txtvalueD.Text)

        valueE = CDbl(txtE.Text)
        valueF = CDbl(txtF.Text)
        valueG = CDbl(txtG.Text)
        valueH = CDbl(txtH.Text)


    End Sub

    Private Sub DefineGraph()
        'graphCaRate1 = New Graph(pbCagate, MinX1, MaxX1, MinY1, MaxY1)   'rate of RyR kinetics 
        graphVmRate2 = New Graph2014(pbVgate, MinX2, MaxX2, MinY1, MaxY1)
        graphCaKD3 = New Graph2014(pbKD, MinX3, MaxX3, MinY1, MaxY1)
        graphSS4 = New Graph2014(pbSS, minX4, maxX4, minY4, maxY4)
        graphTau = New Graph2014(pbTau, minX4, maxX4, minY5, maxY5)
        graphLCCCaRate6 = New Graph2014(pbGate6, minX4, maxX4, MinY1, MaxY1)
    End Sub

    Private Sub DrawAxes()
        graphCaKD3.DrawAxis(IntervalX3, IntervalY1, "Cads vs Vm when LCC is open", 12)
        graphVmRate2.DrawAxis(IntervalX2, IntervalY1, "rate of vm gate", 12)
        graphSS4.DrawAxis(intervalX4, intervalY4, "", 12)
        graphTau.DrawAxis(intervalX4, intervalY5, "", 12)
        graphLCCCaRate6.DrawAxis(intervalX4, IntervalY1, "", 12)
    End Sub
    Private Sub PlotData()
        '**************** Mewes Ravens 1994 ************************
        graphSS4.PlotPoint(-35, 0, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-30, 0.007752, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-25, 0.031, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-20, 0.100775, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-15, 0.1976, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-10, 0.3449, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-5, 0.50775, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(0, 0.66666, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(5, 0.8023, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(10, 0.8992, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(15, 0.9767, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(20, 1.0077, RedPen4)   'steady-state inactivation curve

        '**************** Pelzmann et al 1998 ************************
        graphSS4.PlotPoint(-30, 0.0465, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-20, 0.13565, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-10, 0.37984, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(0, 0.68992, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(10, 0.92248, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(20, 0.98449, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(30, 0.93798, BluePen4)   'steady-state inactivation curve

        '**************** Magyar et al 2000 ************************
        graphSS4.PlotPoint(-35, 0, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-30, 0.0155, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-25, 0.01551, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-20, 0.00775, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-15, 0.04263, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-10, 0.17829, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-5, 0.465166, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(0, 0.7248, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(5, 0.87209, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(10, 0.96124, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(15, 1, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(20, 1.0155, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(25, 1.01162, ChocolatePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(30, 0.992248, ChocolatePen4)   'steady-state inactivation curve

        '************* Steady-state inactivation ***Li et al 1999********************
        graphSS4.PlotPoint(-70, 0.99604, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-60, 0.97628, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-50, 0.9328, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-40, 0.79051, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-30, 0.5138, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-20, 0.22529, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-10, 0.07905, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(0, 0.02371, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(10, 0.02766, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(20, 0.02766, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(30, 0.03162, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(40, 0.075099, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(50, 0.118577, BlackPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(60, 0.166, BlackPen4)   'steady-state inactivation curve

        '**************** Pelzmann et al 1998 ************************
        graphSS4.PlotPoint(-45, 0.98824, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-40, 0.952569, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-35, 0.901186, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-30, 0.83004, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-25, 0.711462, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-20, 0.55336, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-15, 0.37154, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-10, 0.252964, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-5, 0.173913, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(0, 0.142292, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(5, 0.130435, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(10, 0.12253, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(15, 0.110672, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(20, 0.110672, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(25, 0.15019, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(30, 0.162055, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(35, 0.197628, BluePen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(40, 0.229249, BluePen4)   'steady-state inactivation curve
        '**************** Meves et al ***************************

        graphSS4.PlotPoint(-60, 0.9565, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-55, 0.9604, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-50, 0.9644, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-45, 0.996, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-40, 0.98814, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-35, 0.93228, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-30, 0.79841, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-25, 0.620553, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-20, 0.438735, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-15, 0.245059, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-10, 0.13834, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(-5, 0.07114, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(0, 0.07114, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(5, 0.083004, RedPen4)   'steady-state inactivation curve
        graphSS4.PlotPoint(10, 0.1067, RedPen4)   'steady-state inactivation curve

        '**************** Tau of the Ca-inactivation Beuckelmann***************a*********
        graphTau.PlotPoint(-30, 184.61, RedPen4)
        graphTau.PlotPoint(-20, 40.72398, RedPen4)
        graphTau.PlotPoint(-10, 22.624, RedPen4)
        graphTau.PlotPoint(0, 23.529, RedPen4)
        graphTau.PlotPoint(10, 30.769, RedPen4)
        graphTau.PlotPoint(20, 31.819, RedPen4)
        graphTau.PlotPoint(30, 52.488, RedPen4)

        graphTau.PlotLine(-30, 184.61, -20, 40.72398, RedPen)
        graphTau.PlotLine(-20, 40.72398, -10, 22.624, RedPen)
        graphTau.PlotLine(-10, 22.624, 0, 23.529, RedPen)
        graphTau.PlotLine(0, 23.529, 10, 30.769, RedPen)
        graphTau.PlotLine(10, 30.769, 20, 31.819, RedPen)
        graphTau.PlotLine(20, 31.819, 30, 52.488, RedPen)
        '**************** Tau of the Ca-inactivation  Pelzmann************************
        graphTau.PlotPoint(-30, 220.814, BluePen4)
        graphTau.PlotPoint(-20, 117.64, BluePen4)
        graphTau.PlotPoint(-10, 100.452, BluePen4)
        graphTau.PlotPoint(0, 68.778, BluePen4)
        graphTau.PlotPoint(10, 61.538, BluePen4)
        graphTau.PlotPoint(20, 63.348, BluePen4)
        graphTau.PlotPoint(30, 108.59, BluePen4)
        graphTau.PlotLine(-30, 220.814, -20, 117.64, BluePen)
        graphTau.PlotLine(-20, 117.64, -10, 100.452, BluePen)
        graphTau.PlotLine(-10, 100.452, 0, 68.778, BluePen)
        graphTau.PlotLine(0, 68.778, 10, 61.538, BluePen)
        graphTau.PlotLine(10, 61.538, 20, 63.348, BluePen)
        graphTau.PlotLine(20, 63.348, 30, 108.59, BluePen)

        '**************** Fulop et al., 2004 ************************
        graphTau.PlotPoint(-40, 61.9, ChocolatePen4)
        '**************** Pelzmannetal, 1998 ************************
        graphTau.PlotPoint(-40, 60.7, BlackPen4)    'fast component
        graphTau.PlotPoint(-40, 310, BlackPen4)    'slow component
        graphTau.PlotLine(-40, 60.7, -40, 310, GrayPen)    'slow component




    End Sub

    Private Sub clear()
        graphVmRate2.Clear()
        graphCaKD3.Clear()
        graphSS4.Clear()
        graphTau.Clear()
        graphLCCCaRate6.Clear()
    End Sub

    Private Sub ButtonEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonEnd.Click
        End
    End Sub
End Class