﻿'All program codes are developed in the Biosimulation laboratory, Faculty of Life Sciences, Ritsumeikan University
'Reference; Publications
'A human ventricular myocyte model with refined representation of excitation-contraction coupling 
'Running title;                        'CICR in human ventricular cell model
'Authors;    'Y. Himeno†, K. Asakura†‡, C.Y. Cha†1, H. Memida†, T. Powell2, A. Amano†, and A. Noma†. 
'†Biosimulation Project, College of Life Sciences, Ritsumeikan University,
'Noji Higashi 1-1-1 Kusatsu-City, Shiga-prefecture, Japan
'‡Nippon Shinyaku, Co., Ltd., 14, Nishinosho-Monguchi-cho, Kisshoin, Minami-ku, Kyoto, Japan
'1Oxford Centre for Diabetes Endocrinology and Metabolism,
'University of Oxford, Churchill Hospital, Oxford, OX37 LJ, UK.
'2Department of Pharmacology, University of Oxford, Oxford OX1 3QT, UK

'Solution explorer lists all subclasses.
'Calculate.vb provides tools for Disk Write and Read
'Form.APClamp.vb ;   protocol of the Action potetial clamp experiment
'Form.General.vb;       protocol of the current clamp experiments
'Form.ICaLkinetics.vb ;   protocol to draw kinetics of LCC
'Form.RyRtransient.vb;  protocol of the state transition of the couplon model at the onset of action potential
'Form.scaleI1I2;  protocol for simulation of EAD  by varying the inactivation rate of INaL by using the scaling factor for kI1I2, and DAD by injecting 1~1.5 mM Ca into SRup compartment
'Form.VmClampIV.vb;  protocol of Vm clamp experiment
'Graph.vb; home-made tools for Graphics
'Graph2014.vb  home-made tools for Graphics in 2014
'Model.vb;    All equations of HuVEC model are described in this module class
'
'To select a 'Form' to run the protocol of interest, use 'My Project'  and select a Start up form (O) from the pull-down list in the solution explorer.



Imports System.IO
Public Class Form_EADDAD

    '********** prepared pens **********
    Public BlackPen As Pen = New Pen(Color.Black, 1)
    Public BlackPen2 As Pen = New Pen(Color.Black, 2)
    Public BlackPen3 As Pen = New Pen(Color.Black, 3)
    Public BluePen As Pen = New Pen(Color.Blue, 1)
    Public BluePen2 As Pen = New Pen(Color.Blue, 2)
    Public RedPen As Pen = New Pen(Color.Red, 1)
    Public RedPen2 As Pen = New Pen(Color.Red, 2)
    Public ChocolatePen As Pen = New Pen(Color.Chocolate, 1)
    Public ChocolatePen2 As Pen = New Pen(Color.Chocolate, 2)
    Public GreenPen As Pen = New Pen(Color.Green, 1)
    Public GreenPen2 As Pen = New Pen(Color.Green, 2)
    Public OlivePen As Pen = New Pen(Color.Olive, 1)
    Public LimePen As Pen = New Pen(Color.Lime, 1)
    Public GreenYellowPen As Pen = New Pen(Color.GreenYellow, 1)
    Public LightCoralPen As Pen = New Pen(Color.LightCoral, 1)
    Public MagentaPen As Pen = New Pen(Color.Magenta, 1)
    Public MagentaPen2 As Pen = New Pen(Color.Magenta, 2)
    Public VioletPen As Pen = New Pen(Color.Violet, 1)
    Public GrayPen As Pen = New Pen(Color.Gray, 1)
    Public GrayPen2 As Pen = New Pen(Color.Gray, 2)
    Public DarkCyanPen As Pen = New Pen(Color.DarkCyan, 1)
    Public DarkMagentaPen As Pen = New Pen(Color.DarkMagenta, 1)
    Public OrangePen As Pen = New Pen(Color.Orange, 1)
    Public cyanPen As Pen = New Pen(Color.Cyan, 1)
    Public cyanPen2 As Pen = New Pen(Color.Cyan, 2)
    Public yellowPen As Pen = New Pen(Color.Yellow, 1)
    Public yellowPen2 As Pen = New Pen(Color.Yellow, 2)
    Public whitePen As Pen = New Pen(Color.White, 1)

    '********** Graph option **********
    Dim graphVm1 As Graph2014
    Dim graphIm2 As Graph2014
    Dim graphSRCa As Graph2014
    Dim graphGate4a As Graph2014
    Dim graphCa As Graph2014
    Dim graphGate4b As Graph2014

    Dim graphDt As Graph2014                 'ms, adaptive dt

    Dim graphBuffer5 As Graph2014
    Dim graphTimeChange6 As Graph2014
    Dim graphINaLgate As Graph2014
    Dim graphIK18 As Graph2014
    Dim graphRate9 As Graph2014
    Dim graphConc As Graph2014
    ''******************************   Graph parameters **********************************
    Dim MinX1 As Double = 0                               'msec, Abscissa of the graph
    Dim MaxX1 As Double = 1600  '2500                                '2600
    Dim IntervalX1 As Double = 200 '500                            '200

    Dim MinY1 As Double = -100                          'mV, ordinate, graph of membrane potential
    Dim MaxY1 As Double = 40
    Dim IntervalY1 As Double = 10

    Dim MinY2 As Double = -0.6                                  'pA/pF, or uM, ordinate , graph of Current
    Dim MaxY2 As Double = 0.1
    Dim IntervalY2 As Double = 0.1

    Dim MinY3b As Double = 0                                  'mM, or uM, ordinate , graph of Concentrations                                '
    Dim MaxY3b As Double = 10
    Dim IntervalY3b As Double = 5

    Dim MinY3 As Double = 0                                  'dimensionless, ordinate , graph of INaL gating                                '
    Dim MaxY3 As Double = 2
    Dim IntervalY3 As Double = 0.2

    Dim MinX4 As Double = 0                                  'unitless, Gating variable
    Dim MaxX4 As Double = 2000
    Dim IntervalX4 As Double = 500

    Dim MinY4 As Double = 0                                  'unitless, Gating variable
    Dim MaxY4 As Double = 0.2
    Dim IntervalY4 As Double = 0.1

    Dim MinY4b As Double = 0.8                                  'unitless, Gating variable
    Dim MaxY4b As Double = 1.001
    Dim IntervalY4b As Double = 0.1

    Dim MinX5 As Double = 0
    Dim MaxX5 As Double = 800
    Dim IntervalX5 As Double = 100

    Dim MinY5 As Double = 0                                   'mN/cm2
    Dim MaxY5 As Double = 10
    Dim IntervalY5 As Double = 100

    Dim MinX6 As Double = 0                                   ' s
    Dim MaxX6 As Double = 100                             ' s
    Dim IntervalX6 As Double = (MaxX6 - MinX6) / 10

    Dim MinY6 As Double = 0
    Dim MaxY6 As Double = 10
    Dim IntervalY6 As Double = (MaxY6 - MinY6) / 10

    Dim MinY7 As Double = 0
    Dim MaxY7 As Double = 0.8
    Dim IntervalY7 As Double = 0.1

    Dim MinY8 As Double = 0
    Dim MaxY8 As Double = 0.006
    Dim IntervalY8 As Double = 0.001

    Dim MinY9 As Double = 0
    Dim MaxY9 As Double = 0.3
    Dim IntervalY9 As Double = 0.1


    Dim MinY10 As Double = 0              'dt
    Dim MaxY10 As Double = 0.2
    Dim IntervalY10 As Double = 0.05

    Dim MinY11 As Double = 0              'mM,   concentration
    Dim MaxY11 As Double = 20
    Dim IntervalY11 As Double = 2

    Dim HV As New HuVECIII

    'Dim VL As LeadPotential5

    '********** File to hold time variables **********
    Dim CsvFileName As String = "CsvHuVEC.csv"
    Dim names1() As String = New String() {"Vm", "TnChCa", "CaMCa", "bufferSRCa", "Lb_jnc", "Lb_iz", "Hb_jnc", "Hb_iz", "Nai", "Ki", _
                                           "Catot_jnc", "Catot_iz", "Catot_blk", "Ca_SRup", "Catot_SRrl", "O_TM", "I2_TM", "Is_TM", "O_LSM", _
                                           "I1_LSM", "I2_LSM", "Is_LSM", "Yco_iz", "Yoc_iz", "Yoo_iz", "Yco_blk", "Yoc_blk", "Yoo_blk", "Yooo", _
                                           "Yooc", "Ycoo", "Ycoc", "Ycco", "Yoco", "Yocc", "y1_IKr", "y2_IKr", "y3_IKr", "Ov_IKs", "C2IKs_iz", _
                                           "OcIKs_iz", "C2IKs_blk", "OcIKs_blk", "a_IKto", "y1_IKto", "y2_IKto", "Pbspm", "E1NCX_iz", "I1NCX_iz", "I2NCX_iz", "E1NCX_blk", _
                                           "I1NCX_blk", "I2NCX_blk", "P1_6_NaK", "P7_NaK", "P8_13_NaK", "halfSL", "Fb", "Fp", "TSCa3", "TSCa3W", _
                                           "TSCa3S", "TSS", "TSW", "hw", "hp", "ATPt_cyt", "ADPt_cyt", "Pi_cyt", "PCr_cyt", "ATPt_mit", "Pi_mit", _
                                           "NADH_mit", "H_mit", "K_mit", "UQr_mit", "ctCrd_mit", "dpsi", "dT"}

    '********** Membrane current component **********
    Public onset As Double = 50     'start time of external stimulation
    Public offset As Double = 53    'end time of external stimulation

    '********** Time step **********
    Public chartTime As Double = 0             'msec, experimental time
    Public sweepTime As Double                     'msec   time for each sweep
    'Public dt As Double = 0.02                        'ms, time step for integration
    Dim TtoPlot As Double                               'msec timing for plot the point
    Dim maxTtoPlot As Double = 0.05           '
    '**********     counter     *****************************************
    Public Repeat As Double = 0                        'counter of sweeps
    Public maxRepeat As Double = 1                 'maximum number of sweeps

    Dim fileNo As Integer                              'File handler
    Dim strData As String
    Dim valueArray() As String
    '***************************************** save data during simulation *******************************************************
    Dim IsRecord As Boolean
    Dim FileName1 As String
    Dim sw1 As StreamWriter
    Dim RecordTimeStart As Double
    Dim RecordDuration As Double
    Dim RecordInterval As Double
    Dim TtoRecord As Double

    Public Tfreeze As Double = 0
    Dim freezeINaL As Boolean = False

    Dim IsAddCaNa As Boolean = False
    Dim IsFreezeSR As Boolean = False

    Dim maxValue1 As Double = 0
    Dim maxValue2 As Double = 0
    Dim maxValue3 As Double = 0

    Public dt As Double = 0.02    '             Definition of dt in the Model, because the value of dt is modified in this method, dt is stored in CSVRW
    Public adjustStepSize As Boolean = True      'used to determine if the adaptive dt is used or not

    Dim FirstDraw As Boolean = True


    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click
        ButtonStart.Visible = False
        If FirstDraw = True Then                           'only when starting simulation
            MaxX1 = CDbl(txtDuration.Text)
            IntervalX1=MaxX1/8

            DefineGraph()                                    'define graphs
            Clear()                                                'clear graphs
            DrawAxes()
            FirstDraw = False
        End If


        HV.DefaultValues()                            'default values of all variables of the HuVEC model
        ReadForm()                                         'Stimulus strength & Sweeptime max

        '''''''''''''''''''''''''''''''''''''''''''''''''''EAD / DAD'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        If IsFreezeSR Then
            HV.freezeSR = 0
        Else
            HV.freezeSR = 1                          'default
        End If
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        maxValue1 = 0                                                            'to measure the maximum value of Fb 
        maxValue2 = 0
        maxValue3 = 0

        'If freezeINaL Then
        '    graphVm1.PlotLine(Tfreeze, MinY1, Tfreeze, MaxY1, RedPen)          ' Draw a red vertical line when freezing slow variables
        '    graphINaLgate.PlotLine(Tfreeze, MinY7, Tfreeze, MaxY7, RedPen)  ' Draw a red vertical line when freezing slow variables
        'End If

        'DrawAxes()
        Repeat = 0
        chartTime = 0
        Do
            If Repeat >= 1 Then
                HV.Samplitude = 0 'avoid repetitive stimulation
                Clear()
            End If

            sweepTime = 0                          'reset sweepTime = 0
            Do                                  'Calculate individual sweeps of the simulation
                My.Application.DoEvents()                                       'check events

                If IsAddCaNa Then                                  'Ca injection for a duration of 2 ms (= 102 - 100 ms)
                    If chartTime >= 100 And chartTime < 102 Then HV.Ca_SRup = CDbl(txtCaplus.Text) 'keep [Ca] in the SR_up 

                Else
                    HV.Ca_SRup = 0.81532115796704774                      'default value       copy of the default value set
                End If

                If freezeINaL = True Then
                    If Repeat = 0 Then graphVm1.PlotLine(Tfreeze, MinY1, Tfreeze, MaxY1, RedPen) ' Draw a red vertical line when freezing slow variables
                    If Repeat = 0 Then graphINaLgate.PlotLine(Tfreeze, MinY7, Tfreeze, MaxY7, RedPen) ' Draw a red vertical line when freezing slow variables

                    If chartTime > Tfreeze Then         'fix the slow inactivation of INa
                        HV.fixzero_INaLslowgate = 0
                    Else
                        HV.fixzero_INaLslowgate = 1
                    End If
                Else
                    HV.fixzero_INaLslowgate = 1
                End If

                'HV.HeunIntegration(adjustStepSize, sweepTime, dt)
                dt = 0.001
                HV.ConvIntegration(sweepTime, dt)

                ''''''''''''''''''''''''''''''''''''  measure max of Fb, Ca_blk, APD at -78 mV    ''''''''''''''''''''''''''
                If HV.Fb > maxValue1 Then maxValue1 = HV.Fb
                If HV.Cafree_blk > maxValue2 Then maxValue2 = HV.Cafree_blk
                If sweepTime > 100 And HV.Vm < -78 And HV.Vm > -78.5 Then maxValue3 = sweepTime - 53 'APD at ~-78 mV

                ''''''''''''''''''''''''''''''''''''''''plot  results''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                If TtoPlot > maxTtoPlot Then                                                  'time to plot
                    PlotResults()
                    TtoPlot = 0                                                  'reset the timer
                Else
                    TtoPlot = TtoPlot + dt                                       'msec, interval of point plot
                End If

                'If IsRecord = True Then
                '    WriteCSV()
                'End If
                '********************************************************************************************************************

                sweepTime = sweepTime + dt                                  'msec, proceed with the experimental time within one sweep
                chartTime = chartTime + dt                              'msec, proceed with the experimental time       
            Loop While sweepTime < MaxX1

            WritetxtBox()                                                                  'write final values of several variables

            'If chkFwrite.Checked = True Then
            '    CSVReadAndWrite.CreateNewCSV(CsvFileName, HV, names1)   'Replace the old CSV file with a new one, and prepare the headings
            '    CSVReadAndWrite.WriteCSV(CsvFileName, sweepTime, HV, 1, names1)   'input = C(i), output = CsvFileName The variables of only C(1) is stored on the CSV file
            'End If
            Repeat = Repeat + 1
            'If Repeat > 1 Then HV.Samplitude = 0 'avoid repetitive current stimulus
            'count number of sweeps calculated
        Loop While Repeat < maxRepeat

        'Repeat = 0
        ButtonStart.Visible = True

    End Sub

    Private Sub fixSlowVariables()


    End Sub

    Private Sub ButtonEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonEnd.Click
        End
    End Sub

    Public Sub ReadForm()
        adjustStepSize = False

        If chkFreezeMit.Checked Then
            HV.intactMit = False
        Else
            HV.intactMit = True
        End If

        maxRepeat = CDbl(txtRepeat.Text)

        HV.BlinkS = False                   'No blink space is included in the model

        HV.Samplitude = CDbl(txtStimulus.Text)        'amplitude of the stimulus current in pA

        HV.sclI1I2 = CDbl(txtI1I2.Text)                    'scaling factor for kI1I2 of the late scattered mode Na channel

        Tfreeze = CDbl(txtTfreeze.Text)           'time to freeze slow variables

        If cbfreezeM.Checked = True Then
            HV.IsMClamp = True                             'freeze all membrane ion fluxes
        Else
            HV.IsMClamp = False                           'defalt value
        End If

        If cbFreezeINaL.Checked = True Then
            freezeINaL = True                   'Fix slow variables
        Else
            freezeINaL = False
        End If

        '************** Ca dynamics **********************
        If cbAddCaNa.Checked = True Then
            IsAddCaNa = True                         'to examine the Ca clock
        Else
            IsAddCaNa = False
        End If

        If cbFreezeSR.Checked = True Then
            HV.freezeSR = 0
        Else
            HV.freezeSR = 1                          'default
        End If

        '********** IK1, IKr modifications **************
        'HV.SSIK1kinetics = False

        If chkIK1.Checked Then
            HV.SSIK1kinetics = True
        Else
            HV.SSIK1kinetics = False
        End If

        HV.scale_IK1 = CDbl(txtscaleIK1.Text)
        HV.scaleIKr = CDbl(txtscaleIKr.Text)

        '************* general conditions ***********************
        HV.IsoMetric = True                                'isometric contraction
        HV.isometricL = 0.97                               'halfsarcomere length 
        HV.clampMode = "Iclamp"         'always Current Clamp Mode
        HV.fNaK = 1

    End Sub

    Private Sub DefineGraph()
        graphVm1 = New Graph2014(pbVm, MinX1, MaxX1, MinY1, MaxY1)
        graphINaLgate = New Graph2014(PB7, MinX1, MaxX1, MinY7, MaxY7)
        graphIm2 = New Graph2014(pbCurrent, MinX1, MaxX1, MinY2, MaxY2)
        graphSRCa = New Graph2014(pbConcentrationa, MinX1, MaxX1, MinY3, MaxY3)
    End Sub

    Private Sub DrawAxes()
        graphVm1.DrawAxis(IntervalX1, IntervalY1, "", 9)
        graphINaLgate.DrawAxis(IntervalX1, IntervalY7, "", 9)
        graphIm2.DrawAxis(IntervalX1, IntervalY2, "", 9)
        graphSRCa.DrawAxis(IntervalX1, IntervalY3, "", 9)

        'graphCa.DrawAxis(IntervalX1, IntervalY3b, "", 9)
        'graphGate4a.DrawAxis(IntervalX1, IntervalY4, "", 9)
        'graphGate4b.DrawAxis(IntervalX1, IntervalY4b, "", 9)
        'graphIK18.DrawAxis(IntervalX1, IntervalY8, "", 9)
        'graphConc.DrawAxis(IntervalX1, IntervalY11, "", 9)

    End Sub

    Private Sub Clear()
        graphVm1.Clear()
        graphINaLgate.Clear()
        graphIm2.Clear()
        graphSRCa.Clear()

        'graphCa.Clear()
        'graphGate4a.Clear()
        'graphGate4b.Clear()
        'graphIK18.Clear()
        'graphConc.Clear()

        DrawAxes()

    End Sub

    Private Sub PlotResults()

        graphVm1.PlotPoint(sweepTime, HV.Vm, BlackPen)                               'mode A
        graphINaLgate.PlotPoint(sweepTime, 1 - (HV.I2_LSM + HV.Is_LSM), RedPen)
        graphSRCa.PlotPoint(sweepTime, HV.Cafree_SRrl, BlackPen2)
        graphSRCa.PlotPoint(sweepTime, HV.Ca_SRup, BluePen)
        graphIm2.PlotPoint(sweepTime, HV.INaL, BlackPen)

    End Sub

    'Private Sub WriteCSV()
    '    'If sweepTime >= RecordTimeStart And sweepTime <= RecordTimeStart + RecordDuration Then
    '    '    If TtoRecord >= RecordInterval Then

    '    '        sw1.Write("{0:E}" & "," & "{1:E}" & ",", _
    '    '              sweepTime, Vm)


    '    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' for lead potential analysis'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    '    'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & ",", _
    '    '      sweepTime, Vm, VL.TempVL1(0), VL.TempVL1(3))

    '    'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & "," & "{4:E}" & "," & "{5:E}" & "," & "{6:E}" & "," & "{7:E}" & "," & "{8:E}" & "," _
    '    '          & "{9:E}" & "," & "{10:E}" & "," & "{11:E}" & "," & "{12:E}" & "," & "{13:E}" & "," & "{14:E}" & ",", _
    '    '         sweepTime, pO_INa_TM, pO_INa_LSM, pO_CaL_jnc, pO_CaL_nrs, pO_CaL_blk, pO_IKs_nrs, pO_IKs_blk, Vrctf_Kpl, _
    '    '         pO_IKto, pO_LCa_nrs, pO_LCa_blk, pO_IK1, pO_IKr, pO_IKTP)
    '    'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & "," & "{4:E}" & "," & "{5:E}" & "," & "{6:E}" & "," & "{7:E}" & ",", _
    '    '         sweepTime, Nai, Ki, Ca_jnc, Ca_nrs, Ca_blk, MgATP_cyt, MgADP_cyt)

    '    '      sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & "," & "{4:E}" & "," & "{5:E}" & "," & "{6:E}" & "," & "{7:E}" & "," & "{8:E}" & "," _
    '    '& "{9:E}" & "," & "{10:E}" & "," & "{11:E}" & "," & "{12:E}" & "," & "{13:E}" & "," & "{14:E}" & "," _
    '    '& "{15:E}" & "," & "{16:E}" & "," & "{17:E}" & "," & "{18:E}" & "," & "{19:E}" & "," & "{20:E}" & "," & "{21:E}" & "," & "{22:E}" & ",", _
    '    'sweepTime, INa_TM, INa_LSM, ICaLCa_jnc + ICaLNa_jnc + ICaLK_jnc, ICaLCa_nrs + ICaLNa_nrs + ICaLK_nrs, ICaLCa_blk + ICaLNa_blk + ICaLK_blk, _
    '    'IKs_K_nrs + IKs_Na_nrs, IKs_K_blk + IKs_Na_blk, IKpl, IKto, IbNSC, ICab_nrs, ICab_blk, ILCa_Na_nrs + ILCa_K_nrs, ILCa_Na_blk + ILCa_K_blk, _
    '    'IK1, IKr, IKATP, IPMCA_Ca_nrs, IPMCA_Ca_blk, INaK, INCXNa_nrs + INCXCa_nrs, INCXNa_blk + INCXCa_blk)

    '    'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & ",", _
    '    '      sweepTime, VL.TempVL1(1), VL.TempVL1(2))
    '    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


    '    'sw1.Write(Chr(13) & Chr(10))

    '    'TtoRecord = TtoRecord - RecordInterval
    '    '    End If
    '    'End If
    '    'TtoRecord += dt
    'End Sub

    Private Sub WriteCSVB()

        'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & "," & "{4:E}" & "," & "{5:E}" & ",", _
        '             elapsedTime + 80000, maxValue1, Cafree_SRrl, maxValue2, Nai, maxValue3)
        'sw1.Write(Chr(13) & Chr(10))

    End Sub

    Private Sub WritetxtBox()
        txtATPi.Text = Format(HV.ATPt_cyt, "#0.###")
        txtINaLavl.Text = Format(1 - (HV.I2_LSM + HV.Is_LSM), "0.####")
        'txtIs_LSM.Text = Format(HV.Is_LSM, "#.#####") 
        'txtNai.Text = Format(HV.Cafree_SRrl, "##.##########")
        'txtNanrs.Text = Format(maxValue2, "##.##########")
        'txtKblk.Text = Format(HV.Nai, "###.#########")
        'txtCai.Text = Format(maxValue3, "##.#####")
        'txtCaj.Text = Format(0, "###.########")
        'txtCasl.Text = Format(0, "##.########")
        'txtCasl.Text = Format(maxValue3, "##.########")
        'txtCaSR.Text = Format(Ca_SRrl, "##.######")

    End Sub

    Private Sub cbReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbReset.Click
        Repeat = maxRepeat + 1
        sweepTime = MaxX1 + 5
    End Sub

    Private Sub cbErase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbErase.Click
        Clear()

        DrawAxes()
    End Sub


    Private Sub RecordingCondition()
        FileName1 = Path.Combine(Application.StartupPath, "xresult1.csv")
        sw1 = New StreamWriter(FileName1, False)

        If RecordTimeStart + RecordDuration > MaxX1 Then
            RecordDuration = MaxX1 - RecordTimeStart

        End If

        TtoRecord = -RecordTimeStart                 'time interval for saving the data points on the CVS file

        If RecordInterval < dt Then
            RecordInterval = dt
        End If
    End Sub

    'Private Sub pbVm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbVm.Click

    'End Sub
    'Private Sub GroupBox1_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtIKramp.Enter

    'End Sub
    'Private Sub Label24_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub GroupBox2_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GroupBox2.Enter

    'End Sub
    'Private Sub pbGate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub pbBuffer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub GroupBox3_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GroupBox3.Enter

    'End Sub
    'Private Sub PB7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PB7.Click

    'End Sub
    'Private Sub pbConcentration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub Label19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub PBIK1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub pbCurrent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbCurrent.Click

    'End Sub
    'Private Sub Label20_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub Label21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub Label22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
    'Private Sub Label23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    'End Sub
End Class